package polimi.se.battaglia;

import java.util.ArrayList;

public class Griglia {
	Nave[][] g;
	ArrayList navi=new ArrayList<Nave>();
	
	public Griglia(){
		g=new Nave[Costanti.DIM][Costanti.DIM];
		allocaNavi(Costanti.NUMNAVI);
	}
	
	void allocaNavi(int n){
		for(int i=1;i<=Costanti.NUMNAVI;i++){
			int dim=(Costanti.NUMNAVI-i)/2;
			allocaNave(dim);
		}
	}
	
	private void allocaNave(int dim){
		boolean ok=false;
		
		PosizioneNave pn=null;
		
		while(!ok){
			pn=PosizioneNave.generaPosizioneNaveCasuale(dim);
			ok=controllaSeLibero(pn);
		}
		
		Nave n=new Nave(pn);
		posaNave(n);
	}
	
	private boolean controllaSeLibero(PosizioneNave pn){
		for(int j=0;j<pn.dim;j++){
			int tx=pn.x+pn.s.incx*j;
			int ty=pn.y+pn.s.incy*j;
			if(tx<0 || tx>=Costanti.DIM || ty<0 || ty>=Costanti.DIM || g[tx][ty]!=null)
				return false;
		}
		
		return true;
	}
	
	private void posaNave(Nave n){
		navi.add(n);
		
		for(int j=0;j<n.pn.dim;j++){
			int tx=n.pn.x+n.pn.s.incx*j;
			int ty=n.pn.y+n.pn.s.incy*j;
			g[tx][ty]=n;
		}
		
	}
	
	public void stampaGriglia(){
		for(int i=0;i<Costanti.DIM;i++){
			for(int j=0;j<Costanti.DIM;j++){
				if(g[i][j]==null)
					System.out.print(" 0 ");
				else
					System.out.print(g[i][j].mostraStato(i, j));
			}
			System.out.println();
		}		
	}	
	
	public boolean spara(){
		int x=(int)(Costanti.DIM*Math.random());
		int y=(int)(Costanti.DIM*Math.random());
		
		if(g[x][y]!=null){
			g[x][y].colpo(x, y);
			
			System.out.println("Colpita");
			
			if(g[x][y].affondata())
				System.out.println(" a affondata");			
		}
		
		for(int i=0;i<navi.size();i++){
			Nave n=(Nave)navi.get(i);
			if(!n.affondata())
				return false;
		}
		
		return true;
	}
}
